<?php
/**
* Here are some sample codes for showing how to use the Form class.
* It doesn't show all the possibility, so have a look to the class itself, too.
*
* Markus Bopp, 2003-11-06 01:50:00 CET
*/

include_once("Form.php");

$echolist = "";

// setting up the form
$form = new Form();
$form->setName( "myForm" );
$form->setAction( "somewhere.php" );
$form->setMethod( "post" );
$form->setEnctype( "multipart/form-data" );

// adding the form elements
$form->addText( "TextName", "TextValue" );
$form->addTextarea( "TextareaName", "TextareaValue", "20", "10" );
$form->addCheckbox( "MyCheckbox", "MyCheckboxValue", "checked" );
$form->addRadio( "radio123", "rad1" );
$form->addRadio( "radio123", "rad2", "checked" );
$form->addRadio( "radio123", "rad3" );
$form->addRadio( "radio1234", "rad11" );

// preparing the options for the select field
$options = array( "number1" => 
					array( "value"    => "number1 value", 
						   "selected" => "selected",
						   "extra"    => "style=\"font-size:8pt;\"" ),
				  "number2" =>
				    array( "value" => "number2_value" ) );

$form->addSelect( "mySelect", $options );

$form->addSubmit( "ButtonName", "Send!" );

// retrieve the form (possibility #1)
$echolist .= "POSSIBILITY #1:<br><br>";
$echolist .= $form->getOpenLine();
$echolist .= "radios #1<br>";
$echolist .= "rad1 "       . $form->getElement( "radio123", 0 );
$echolist .= " ";
$echolist .= "rad2 "       . $form->getElement( "radio123", 1 );
$echolist .= " ";
$echolist .= "rad3 "       . $form->getElement( "radio123", 2 );
$echolist .= "<br><br>radios #2<br>";
$echolist .= "rad11 "      . $form->getElement( "radio1234", 0 );
$echolist .= "<br><br>";
$echolist .= "Text<br>"    . $form->getElement( "TextName" );
$echolist .= "<br><br>";
$echolist .= "Textarea<br>". $form->getElement( "TextareaName" );
$echolist .= "<br><br>";
$echolist .= "Select<br>"  . $form->getElement( "mySelect" );
$echolist .= "<br><br>";
$echolist .= "Submit<br>"  . $form->getElement( "ButtonName" );
$echolist .= "<br><br>";
$echolist .= $form->getCloseLine();

// retrieve the form (possibility #2)
// additionally, possibility to add labels via array in the following style
$labels = array( "TextareaName"     => "Take that!",
				// the following is a must if you have multiple radios with the same name
				 "radio123"  =>  array( "value" => "test",    "sub_labels" => array( 0 => "poop", 1 => "poop1", 2 => "poop2" ) ),
				 "radio1234" =>  array( "value" => "test2", "sub_labels" => array( 0 => "poop3" ) ) );

$echolist .= "POSSIBILITY #2:<br><br>";

// print the whole form in one, if leaving all the parameters, all elements will be shown in a row.
// $labels contains an array as shown above.
// 2nd parameter indicates a break after each label.
// 3rd parameter indicates a double break after each form element.
$echolist .= $form->toString( $labels, "<br />\n", "<br /><br />\n" );

echo $echolist;
?>
