<?php

class Table
{
	var $openLine  = "<table[border][width][name][cellspacing][cellpadding][extra]>\n";
	var $closeLine = "</table>\n";
	var $border = "";
	var $width  = "";
	var $name   = "";
	var $cellpadding = "";
	var $cellspacing = "";
	var $extra = "";
	var $rows = array();
	var $nextfree = 0;
	
	function Table()
	{
		// nothing yet ...
	}
	
	function getOpenLine()
	{
		if( strlen( $this->name ) != 0 )
		{
			$this_name = " name=\"" . $this->name . "\"";
		}
		else
		{
			$this_name = "";
		}
		
		if( strlen( $this->border ) != 0 )
		{
			$this_border = " border=\"" . $this->border . "\"";
		}
		else
		{
			$this_border = "";
		}
		
		if( strlen( $this->width ) != 0 )
		{
			$this_width = " width=\"" . $this->width . "\"";
		}
		else
		{
			$this_width = "";
		}
		
		if( strlen( $this->cellpadding ) != 0 )
		{
			$this_cellpadding = " cellpadding=\"" . $this->cellpadding . "\"";
		}
		else
		{
			$this_cellpadding = "";
		}
		
		if( strlen( $this->cellspacing ) != 0 )
		{
			$this_cellspacing = " cellspacing=\"" . $this->cellspacing . "\"";
		}
		else
		{
			$this_cellspacing = "";
		}
		
		if( strlen( $this->extra ) != 0 )
		{
			$this_extra = " " . $this->extra;
		}
		else
		{
			$this_extra = "";
		}
		
		$openLine2 = $this->openLine;
		
		$openLine2 = str_replace( "[name]",        $this_name,        $openLine2 );
		$openLine2 = str_replace( "[border]",      $this_border,      $openLine2 );
		$openLine2 = str_replace( "[width]",       $this_width,       $openLine2 );
		$openLine2 = str_replace( "[cellpadding]", $this_cellpadding, $openLine2 );
		$openLine2 = str_replace( "[cellspacing]", $this_cellspacing, $openLine2 );
		$openLine2 = str_replace( "[extra]",       $this_extra,       $openLine2 );
		
		return $openLine2;
	}
	
	function getCloseLine()
	{
		return $this->closeLine;	
	}
	
	function setBorder( $num )
	{
		$this->border = $num;
	}
	
	function setWidth( $width )
	{
		$this->width = $width;
	}
	
	function setName( $name )
	{
		$this->name = $name;
	}
	
	function setCellPadding( $num )
	{
		$this->cellpadding = $num;
	}
	
	function setCellSpacing( $num )
	{
		$this->cellspacing = $num;
	}
	
	function setExtra( $extra )
	{
		$this->extra = $extra;
	}
	
	function addRow( $row )
	{
		$this->rows[ $this->nextfree ] = $row;
		$this->nextfree++;
	}
	
	function toString()
	{
		$rows = "";
		$rows_count = count( $this->rows );
		for( $i = 0; $i < $rows_count; $i++ )
		{
			$rows .= $this->rows[ $i ]->toString();
		}
		
		return $this->getOpenLine() . $rows . $this->getCloseLine();	
	}
}

class TableRow
{
	var $openLine  = "<tr[width][height][extra]>\n";
	var $closeLine = "</tr>\n";
	var $width  = "";
	var $height = "";
	var $extra  = ""; 
	var $cols = array();
	var $nextfree = 0;
	
	function TableRow()
	{

	}	
	
	function getOpenLine()
	{
		if( strlen( $this->width ) != 0 )
		{
			$this_width = " width=\"" . $this->width . "\"";
		}
		else
		{
			$this_width = "";
		}
		
		if( strlen( $this->height ) != 0 )
		{
			$this_height = " height=\"" . $this->height . "\"";
		}
		else
		{
			$this_height = "";
		}
		
		if( strlen( $this->extra ) != 0 )
		{
			$this_extra = " " . $this->extra;
		}
		else
		{
			$this_extra = "";
		}
		
		$openLine2 = $this->openLine;
		
		$openLine2 = str_replace( "[width]",  $this_width,  $openLine2 );
		$openLine2 = str_replace( "[height]", $this_height, $openLine2 );
		$openLine2 = str_replace( "[extra]",  $this_extra,  $openLine2 );
		
		return $openLine2;	
	}
	
	function getCloseLine()
	{
		return $this->closeLine;
	}
	
	function setWidth( $width )
	{
		$this->width = $width;
	}
	
	function setHeight( $height )
	{
		$this->height = $height;
	}
	
	function setExtra( $extra )
	{
		$this->extra = $extra;
	}
	
	function addColumn( $col )
	{
		$this->cols[ $this->nextfree ] = $col;
		$this->nextfree++;
	}
	
	function toString()
	{
		$cols = "";
		$col_count = count( $this->cols );
		for( $i = 0; $i < $col_count; $i++ )
		{
			$cols .= $this->cols[ $i ]->toString();
		}
		
		return $this->getOpenLine() . $cols . $this->getCloseLine();	
	}
}

class TableColumn
{
	var $openLine  = "<td[width][height][rowspan][colspan][valign][align][extra]>\n";
	var $closeLine = "</td>\n";
	var $width     = "";
	var $height    = "";
	var $rowspan   = "";
	var $colspan   = "";
	var $extra     = ""; 
	var $value     = "";
	var $valign    = "";
	var $align     = "";
	
	function TableRow()
	{
		// nothing yet ...
	}	
	
	function getOpenLine()
	{
		if( strlen( $this->width ) != 0 )
		{
			$this_width = " width=\"" . $this->width . "\"";
		}
		else
		{
			$this_width = "";
		}
		
		if( strlen( $this->height ) != 0 )
		{
			$this_height = " height=\"" . $this->height . "\"";
		}
		else
		{
			$this_height = "";
		}
		
		if( strlen( $this->rowspan ) != 0 )
		{
			$this_rowspan = " rowspan=\"" . $this->rowspan . "\"";
		}
		else
		{
			$this_rowspan = "";
		}
		
		if( strlen( $this->colspan ) != 0 )
		{
			$this_colspan = " colspan=\"" . $this->colspan . "\"";
		}
		else
		{
			$this_colspan = "";
		}
		
		if( strlen( $this->valign ) != 0 )
		{
			$this_valign = " valign=\"" . $this->valign . "\"";
		}
		else
		{
			$this_valign = "";
		}
		
		if( strlen( $this->align ) != 0 )
		{
			$this_align = " align=\"" . $this->align . "\"";
		}
		else
		{
			$this_align = "";
		}
		
		if( strlen( $this->extra ) != 0 )
		{
			$this_extra = " " . $this->extra;
		}
		else
		{
			$this_extra = "";
		}
		
		$openLine2 = $this->openLine;
		
		$openLine2 = str_replace( "[width]",   $this_width,   $openLine2 );
		$openLine2 = str_replace( "[height]",  $this_height,  $openLine2 );
		$openLine2 = str_replace( "[rowspan]", $this_rowspan, $openLine2 );
		$openLine2 = str_replace( "[colspan]", $this_colspan, $openLine2 );
		$openLine2 = str_replace( "[valign]",  $this_valign,  $openLine2 );
		$openLine2 = str_replace( "[align]",   $this_align,   $openLine2 );
		$openLine2 = str_replace( "[extra]",   $this_extra,   $openLine2 );
		
		return $openLine2;	
	}
	
	function getCloseLine()
	{
		return $this->closeLine;
	}
	
	function setWidth( $width )
	{
		$this->width = $width;
	}
	
	function setHeight( $height )
	{
		$this->height = $height;
	}
	
	function setRowspan( $amount )
	{
		$this->rowspan = $amount;
	}
	
	function setColspan( $amount )
	{
		$this->colspan = $amount;
	}
	
	function setExtra( $extra )
	{
		$this->extra = $extra;
	}
	
	function setValue( $value )
	{
		$this->value = $value;
	}
	
	function setValign( $valign )
	{
		$this->valign = $valign;
	}
	
	function setAlign( $align )
	{
		$this->align = $align;
	}
	
	function toString()
	{
		return $this->getOpenLine() . $this->value . $this->getCloseLine();	
	}
}
?>