<?
/*
* Using ultratree as base for the trees of phpBlaster
* Originally written by -> http://www.tourbase.ru/zink
* phplib support and multiple trees added by Markus Bopp, 2003-03-06
*
* naming of catid should be different if you want to init multiple trees on one site
* just choose an idname to give to maketree and use it as key in the sql query
*
*/
class Ultratree extends DB_Sql
{
	var $module;
	var $css_class;
	var $pointBack;
	
	function Ultratree()
	{
		$this->module = "news";
		$this->css_class = "treeStyle";
		$this->pointBack = TRUE;
	}

	function maketree($rootcatid,$sql,$maxlevel,$url,$add="",$idname="catid",$parcatname="parcat",$namename="name",$withkey=TRUE)
	{			
    	    $this->query($sql);
			$i=0;	
        	while($this->next_record())
		 	{		 	
         		$table[$this->f($parcatname)][$this->f($idname)]=$this->f($namename);
          		$partable[$this->f($idname)][$this->f($parcatname)]=$this->f($namename);
				$i++;
         	}
			
			if($i==0)
				return "";
			
         	$result .= $this->buildparent($rootcatid,$table,$partable,$url,$idname,$add)."<br>";
         	$result .= $this->makebranch($rootcatid,$table,0,$maxlevel,$url,$add,$idname,$parcatname,$withkey);
         	RETURN $result;
	}

	function makeparent($rootcatid,$sql,$maxlevel,$url,$add="",$idname="catid",$parcatname="parcat",$namename="name",$withkey=TRUE)
	{			
    	    $this->query($sql);
			$i=0;	
        	while($this->next_record())
		 	{		 	
         		$table[$this->f($parcatname)][$this->f($idname)]=$this->f($namename);
          		$partable[$this->f($idname)][$this->f($parcatname)]=$this->f($namename);
				$i++;
         	}
			
			if($i==0)
				return "";
			
         	$result .= $this->buildparental($rootcatid,$table,$partable,$url,$idname,$add);
         	RETURN $result;
	}

	function makebranch($parcat,$table,$level,$maxlevel,$url="",$add,$idname,$parcatname,$withkey)
	{
         $list=$table[$parcat];
         if($add!="comments")
		 	@asort($list); 
         while(list($key,$val)=@each($list))
		 {
         	if ($level=="0")
		    {
				  $width=0;
               	  $output="<img src='classes/ultratree/se.gif' width=12 height=12>";
            }
			else
			{
               	  $width=($level+1)*24;
               	  $output="<img src='classes/ultratree/e.gif' width=$width height=12>";
            }
						
			if($add=="comments")
				$adding = " ".$this->getCommentData($key);
			else if($add=="links" || $add=="downloads" || $add=="news")
				$adding = "<br>\n".$this->addNews($key,$width);
				
			if($withkey)
				$wk =  "($key)";
			else
				$wk = "";
			
			// hack for the censored comments
			if($add=="comments")
			{
				$this->query("SELECT censored FROM "._DBPREFIX."_".$this->module."_comments WHERE id=$key;");
				if($this->next_record())
					if($this->f("censored")==1)
						$result.= "$output <a id=\"".$this->css_class."\" href='$url&$idname=$key'>#########</a>".$adding."<br>\n";
					else
						$result.= "$output <a id=\"".$this->css_class."\" href='$url&$idname=$key'>$val $wk</a>".$adding."<br>\n";
			}
			else				
		        $result.= "$output <a id=\"".$this->css_class."\" href='$url&$idname=$key'>$val $wk</a>".$adding."<br>\n";
                      
			if ((isset($table[$key])) AND (($maxlevel>$level+1) OR ($maxlevel=="0")))
			{
    	    	$result.= $this->makebranch($key,$table,$level+1,$maxlevel,$url,$add,$idname,$parcatname,$withkey);
            }
         }
         RETURN $result;
	}

	function buildparental($catid,$table,$partable,$url,$idname,$add)
	{
         if ($catid!=0)
		 {
         	 $list=$partable[$catid];
         	 $result=@each($list);
			 if($result[1]!="")
			 {
			 	 if( $this->pointBack )
			 	 {
			 	 	$idcat = $result[0];
			 	 }else
			 	 {
			 	 	$idcat = $catid;
			 	 }
			 	 
				 $output="<a id=\"".$this->css_class."\" href='$url&$idname=$idcat'>$result[1]</a> : ";
			 } 
	         $output=$this->buildparental($result[0],$table,$partable,$url,$idname,$add).$output;
         }
         RETURN $output;
	}

	function buildparent($catid,$table,$partable,$url,$idname,$add)
	{
         if ($catid!=0)
		 {
         	 $list=$partable[$catid];
         	 $result=@each($list);
			 // hack for the censored comments
			if($add=="comments")
			{
			 $this->query("SELECT censored FROM "._DBPREFIX."_".$this->module."_comments WHERE id=$catid;");
				if($this->next_record())
					if($this->f("censored")==1)
						$output="<a id=\"".$this->css_class."\" href='$url&$idname=$result[0]'>#########</a> / ";
					else
			    	     $output="<a id=\"".$this->css_class."\" href='$url&$idname=$result[0]'>$result[1]</a> / ";
			}
			else
				 $output="<a id=\"".$this->css_class."\" href='$url&$idname=$result[0]'>$result[1]</a> / ";
				 
	         $output=$this->buildparent($result[0],$table,$partable,$url,$idname,$add).$output;
         }
         RETURN $output;
	}	
	
	function getCommentData($k)
	{
		global $standardtimeformat;
		$cd = "";
		$this->query("SELECT a.creationtime,b.usernameplain FROM "._DBPREFIX."_".$this->module."_comments AS a, "._DBPREFIX."_users AS b WHERE a.userid=b.id AND a.id=$k;");
		if($this->next_record())
		{			
			$cd .= "[" . $this->f("usernameplain").", ".preg_replace("/(\[|\])/","",date($standardtimeformat,strtotime($this->f("creationtime")))) . "]\n";
		}
		else
		{
			// try anonymous
			$this->query("SELECT a.creationtime,b.usernameplain FROM "._DBPREFIX."_".$this->module."_comments AS a, "._DBPREFIX."_users AS b WHERE a.userid=-1 AND a.id=$k;");
			if($this->next_record())
			{
				$cd .= "[Anonymous, ".preg_replace("/(\[|\])/","",date($standardtimeformat,strtotime($this->f("creationtime")))) . "]\n";
			}
			else
			{
				$cd .= "WARNING: Data could not be found!";
			}
		}
		return $cd;
	}
	
	function addNews($k,$width)
	{
		$news = "";
		$this->query("SELECT topic,headline FROM "._DBPREFIX."_".$this->module." WHERE topic=$k ORDER BY headline;");
		while($this->next_record())
		{			
			$news .= "<img src='classes/ultratree/e.gif' width=$width height=1> [".$this->f("headline")."]<br>";
		}
		return $news;
	}
}
?>