<?php
/*
  phpBLASTER, an Open Source Content Management Solution

  Project page:
  http://www.phpblaster.org
  
  Download:
  http://www.phpblaster.org/modules.php?name=Downloads

  Copyright (c) 2003 Markus Bopp

  Released under the GNU General Public License
  
*/
// by ryan@wonko.com from the php.net comments area (http://de.php.net/manual/en/function.get-magic-quotes-gpc.php)
if (get_magic_quotes_gpc() == 0)
{
   function magicSlashes($element)
   {
       if (is_array($element))
           return array_map("magicSlashes", $element);
       else
           return addslashes($element);
   }

   // Add slashes to all incoming GET/POST/COOKIE data.
   $_GET    = array_map("magicSlashes", $_GET);
   $_POST   = array_map("magicSlashes", $_POST);
   $_COOKIE = array_map("magicSlashes", $_COOKIE);
}

include("config.php");
include("phplib/prepend.php3");
include("functions/general.php");
include("functions/ExtendedProfiles.php");

if(isset($HTTP_POST_VARS))
	$_POST = $HTTP_POST_VARS;
	
if(isset($HTTP_GET_VARS))
	$_GET = $HTTP_GET_VARS;

$xdb = new DB_Sql;

// get the preferences
$xdb->query("SELECT * FROM "._DBPREFIX."_preferences WHERE id=1;");
if($xdb->next_record())
{
	$user_max_cookie_lifetime  = intval($xdb->f("user_cookie"));
	$admin_max_cookie_lifetime = intval($xdb->f("admin_cookie"));
	$loginmax   = intval($xdb->f("login_max"));
	$loginmin   = intval($xdb->f("login_min"));
	$loginpwmax = intval($xdb->f("pw_max"));
	$loginpwmin = intval($xdb->f("pw_min"));
	$mailfrom   = $xdb->f("mailfrom");
	$standardtimeformat = $xdb->f("time_format");
	define("_STANDARDTIME",$standardtimeformat);
	if(intval($xdb->f("is_cookie"))==1)
		$isCookie = TRUE;
	else
		$isCookie = FALSE;
	$language = _getLanguageString(intval($xdb->f("language")));
	$sitename = $xdb->f("site_name");
	$siteurl  = $xdb->f("site_url");
	define("_SITENAME",$xdb->f("site_name"));
	define("_SITEURL",$xdb->f("site_url"));
	if(intval($xdb->f("use_gzip"))==1)
		$usegzip = TRUE;
	else
		$usegzip = FALSE;
		
	if($xdb->f("use_socket_mail")=="yes")
		$use_socket_mail = TRUE;
	else
		$use_socket_mail = FALSE;
		
	if(strlen($xdb->f("sm_host"))>0)
		$sm_host = $xdb->f("sm_host");
	else
		$sm_host = ini_get("SMTP");
	
	if(strlen($xdb->f("sm_port"))>0 && $xdb->f("sm_port")!=0)
		$sm_port = $xdb->f("sm_port");
	else
		$sm_port = ini_get("smtp_port");
}

// cleaning up some things. maybe a randomizer will reduce the amount of database requests?
$now = date("Y-m-d H:i:s");
$xdb->query("DELETE FROM "._DBPREFIX."_user_session WHERE valid<'$now';");
$xdb->query("DELETE FROM "._DBPREFIX."_admin_session WHERE valid<'$now';");
$xdb->query("DELETE FROM "._DBPREFIX."_temp_users WHERE valid<'$now';");
$xdb->query("DELETE FROM "._DBPREFIX."_users_tmp_extended_profiles WHERE valid<'$now';");

// at the moment do not try to rename these files. it will be used in future releases.
$adminfilename   = "admin\.php";
$modulesfilename = "modules\.php";
$echolist = "";

ob_start(); // prevent output. flushing by function _flushAll() at the end of each module.

$userdata  = array(4);
$admindata = array(4);

if(!$isCookie){	// in fact the other method(s) also use cookies. should be renamed to $isCookieOnly in the future.
	// DBSESSION STARTS HERE ...
	$sess_user  = _getCookie("blaster_user");
	$sess_admin = _getCookie("blaster_admin");
	
	$xdb->query("SELECT userid FROM "._DBPREFIX."_user_session WHERE session='$sess_user';");	
	if($xdb->next_record())
		$userid = $xdb->f("userid");
	else
		$userid = -1;

	$xdb->query("SELECT * FROM "._DBPREFIX."_users WHERE id='$userid';");	
	if($xdb->next_record()){
		$userdata[0] = $xdb->f("id");
		$userdata[1] = base64_decode($xdb->f("username"));
		$userdata[2] = $xdb->f("email");
		$userdata[3] = $xdb->f("femail");
	}else
	{
		$userdata[0] = -1;
		$userdata[1] = "";
		$userdata[2] = "";
		$userdata[3] = "";
	}
	
	$xdb->query("SELECT userid FROM "._DBPREFIX."_admin_session WHERE session='$sess_admin';");	
	if($xdb->next_record())
		$adminid = $xdb->f("userid");
	else
		$adminid = -1;
	
	$xdb->query("SELECT * FROM "._DBPREFIX."_admins WHERE id='$adminid';");	
	if($xdb->next_record()){
		$admindata[0] = $xdb->f("id");
		$admindata[1] = base64_decode($xdb->f("adminname"));
		$admindata[2] = $xdb->f("email");
		$admindata[3] = $xdb->f("permissions");
	}else
	{
		$admindata[0] = -1;
		$admindata[1] = "";
		$admindata[2] = "";
		$admindata[3] = "";
	}
	// DB SESSION END	
}else{
	$userdata  = _getCookieData("blaster_user");
	$admindata = _getCookieData("blaster_admin");
}

$user  = _getUserType($userdata[0],"users",$xdb);
$admin = _getUserType($admindata[0],"admins",$xdb);

// before we continue, we have to check if the user may have access to the actual loaded module.
$permret = _checkPerms(_getVar("name"),$adminfilename,$modulesfilename,$SCRIPT_NAME,$user,$admin,$xdb);
if($permret!="ISALLOWED"){
	_locationHref("modules.php?name=Error&op=module_error");
	exit;	
}

// bad words
$getPostGet = _getPostGet($_GET,$_POST,$HTTP_GET_VARS,$HTTP_POST_VARS);
if(count($getPostGet)!=0 && !_isAdmin($admin)) // admins may say what they want to say ;)
{
	$xdb->query( "SELECT words FROM "._DBPREFIX."_badwords;" );
	if( $xdb->next_record() )
		$bwords = $xdb->f("words");
	else
		$bwords = "";

	if( strlen( $bwords ) != 0 )
	{
		$pregstr = @_pregstr($bwords);
		$gpstr   = @_gpstr($getPostGet);
	
		if(trim(substr($pregstr,strlen($pregstr)-1,strlen($pregstr))) == "|")
				$pregstr = trim(substr($pregstr,0,strlen($pregstr)-1));
			
		if(preg_match("/$pregstr/",strtolower($gpstr)))
		{
			_locationHref("modules.php?name=Error&op=badword_error");
			exit;	
		}
	}	
}

$theme    = _getTheme(_getCookie("blaster_theme"));
$language = _getLanguage(_getCookie("blaster_language"));

/** $mod & $adm_mod array contain the modules as string (sitewide) */
$mod 	 = _getAnyModules("modules",$xdb);
$adm_mod = _getAnyModules("admin",$xdb);
?>
