<?php
class MessageContainer extends DB_Sql
{
	var $userdata = array();
	var $percentage = 0;
	var $send_max = 0;
	var $color = "";
	var $prewarn_percentage = 0;
	var $prewarn_color = "";
	var $warn_color = "";
	var $ok_color = "";
	var $box = "";
	
	function MessageContainer( $userdata, $box = "inbox" )
	{
		$this->send_max = _PM_CNF_SEND_MAX;
		$this->prewarn_percentage = _PM_CNF_PREWARN;
		$this->warn_percentage = _PM_CNF_WARN;
		$this->prewarn_color = _PM_CNF_PREWARN_COLOR;
		$this->warn_color = _PM_CNF_WARN_COLOR;
		$this->ok_color = _PM_CNF_OK_COLOR;
		
		// don't change this
		$this->userdata = $userdata;
		$this->box = $box;
		$this->color = $this->ok_color;
		if( $box == "inbox" )
			$this->calculateInbox();
		else
			$this->calculateOutbox();
	}
	
	function calculate()
	{
		if( $this->nf() < $this->send_max )
		{
			if( $this->send_max <= 0 )
			{
				$this->send_max = 1;
			}
			
			$this->percentage = round( ( ( $this->nf() / intval( $this->send_max ) ) * 100 ), 2 );
			
			if( $this->percentage >= $this->prewarn_percentage )
			{
				$this->color = $this->prewarn_color;	
			}
			else if( $this->percentage >= $this->warn_percentage )
			{
				$this->color = $this->warn_color;
			}
		}
		else
		{
			$this->percentage = 100;
			$this->color = $this->warn_color;
		}
	}
	
	function calculateOutbox()
	{
		$this->query( "SELECT id FROM " . _DBPREFIX . "_pm_inbox WHERE from_id='{$this->userdata[ 1 ]}' AND to_id<>{$this->userdata[ 0 ]} AND owner={$this->userdata[ 0 ]};" );
		
		$this->calculate();
	}
	
	function calculateInbox()
	{
		$this->query( "SELECT id FROM " . _DBPREFIX . "_pm_inbox WHERE to_id={$this->userdata[ 0 ]} AND owner={$this->userdata[ 0 ]};" );
		
		$this->calculate();
	}
	
	function toString()
	{
		$table = new Table();
		$table->setBorder( 0 );
		$table->setWidth( round( $this->percentage ) . "%" );
		$table_head = new Table();
		$table_head->setBorder( 0 );
		$table_head->setWidth( "100%" );
		$row = new TableRow();
		$col = new TableColumn();
		$row_head = new TableRow();
		$col_head = new TableColumn();
		if( $this->box == "inbox" )
			$col_head->setValue( _PM_MESSAGE_INBOX_CONTAINER );
		else
			$col_head->setValue( _PM_MESSAGE_OUTBOX_CONTAINER );
		$row_head->addColumn( $col_head );
		$col->setExtra( "bgcolor=\"" . $this->color . "\"" );
		$col->setValue( "<b>" . $this->percentage . "%</b>" );
		$row->addColumn( $col );
		$table_head->addRow( $row_head );
		$table->addRow( $row );
		return $table_head->toString() . $table->toString();
	}
}
?>