<?php
class MessageSaver extends DB_Sql
{
	var $error = "";
	var $message = "";
	var $userdata = array();
	var $content = "";
	var $title = "";
	var $to = "";
	var $to_max = 0;
	var $send_max = 0;
	var $outbox_max = 0;
	var $br = "<br />\n";
	var $title_max = 0;
	var $content_max = 0;
	var $userNotFoundMessage = FALSE;
	
	function MessageSaver( $post, $to, $userdata )
	{
		$this->to_max = _PM_CNF_TO_MAX;
		$this->send_max = _PM_CNF_SEND_MAX;
		$this->outbox_max = _PM_CNF_SEND_MAX;
		$this->title_max = _PM_CNF_TITLE_MAX;
		$this->content_max = _PM_CNF_CONTENT_MAX;
		
		// don't change anything from here
		$ok = TRUE;
		if( strlen( $post[ "title" ] ) > $this->title_max )
		{
			$this->error = _PM_MESSAGE_SAVER_TITLE_TO_LONG;
			$ok = FALSE;	
		}
		
		if( strlen( $post[ "content" ] ) > $this->content_max )
		{
			$this->error = _PM_MESSAGE_SAVER_CONTENT_TO_LONG;
			$ok = FALSE;	
		}
		
		if( !isset( $post[ "title" ] ) || strlen( $post[ "title" ] ) == 0 )
		{
			$this->error = _PM_MESSAGE_SAVER_NO_SUBJECT;
			$ok = FALSE;
		}
		
		if( !isset( $post[ "content" ] ) || strlen( $post[ "content" ] ) == 0 )
		{
			$this->error = _PM_MESSAGE_SAVER_NO_TEXT;
			$ok = FALSE;
		}
		
		if( strlen( $to ) == 0 )
		{
			$this->error = _PM_MESSAGE_SAVER_NO_RECIPIENT;
			$ok = FALSE;	
		}else
		{
			$exploded = explode( ",", $to );
			$exploded_length = count( $exploded );
			
			for( $i = 0; $i < $exploded_length; $i++ )
			{
				if( strlen( trim( $exploded[ $i ] ) ) == 0 )
				{
					$this->error = _PM_MESSAGE_SAVER_WRONG_TO_STRING;	
					$ok = FALSE;
					break;
				}
				else
				{
					if( trim( $exploded[ $i ] ) == $userdata[ 1 ] )
					{
						$this->error = _PM_MESSAGE_SAVER_SELF_SEND;
						$ok = FALSE;
						break;
					}
					else
					{
						$exploded[ $i ] = trim( $exploded[ $i ] );	
					}
				}
				
				if( $i > $this->to_max )
				{
					$this->error = _PM_MESSAGE_SAVER_TOO_MANY_RECIPIENTS;	
					$ok = FALSE;
					break;	
				}
			}
			
			if( $ok )
			{	
				$this->title = addslashes( htmlentities( $post[ "title" ] ) );
				$this->content = addslashes( htmlentities( $post[ "content" ] ) );
				$this->userdata = $userdata;
				$this->to = $exploded;
				$this->saveMessage();
			}	
		}
	}

	function saveMessage()
	{
		$to_length = count( $this->to );
		$mess_cnt = 0;
		
		$this->query( "SELECT id FROM " . _DBPREFIX . "_pm_inbox"
					 ." WHERE from_id='" . $this->userdata[ 1 ] . "';" );
		
		if( $this->nf() < $this->outbox_max )						 
		{			
			$userNotFoundMessage = FALSE;			 
			for( $i = 0; $i < $to_length; $i++ )
			{
				$to_id = _getUserIdByName( $this, trim($this->to[ $i ]) );
				
				$this->query( "SELECT id FROM " . _DBPREFIX . "_pm_inbox"
							 ." WHERE to_id=$to_id AND owner={$this->userdata[0]};" );

				if( ($this->nf() < $this->send_max) && intval($to_id) > 0 )
				{		 
					$now = date( "Y-m-d H:i:s" );
					$this->query( "INSERT INTO " . _DBPREFIX . "_pm_inbox"
							 ." (title,"
							 ." content,"
							 ." sendtime,"
							 ." from_id,"
							 ." to_id,"
							 ." owner)"
							 ." VALUES"
							 ." ('". $this->title . "',"
							 ." '" . $this->content . "',"
							 ." '$now',"
							 ." '" . $this->userdata[ 1 ] . "',"
							 ." $to_id,"
							 ." $to_id);");
					
					// copy for the writer of message	 
					$this->query( "INSERT INTO " . _DBPREFIX . "_pm_inbox"
							 ." (title,"
							 ." content,"
							 ." sendtime,"
							 ." from_id,"
							 ." to_id,"
							 ." owner)"
							 ." VALUES"
							 ." ('". $this->title . "',"
							 ." '" . $this->content . "',"
							 ." '$now',"
							 ." '" . $this->userdata[ 1 ] . "',"
							 ." $to_id,"
							 ." {$this->userdata[0]});");
				}
				else if(intval($to_id)==0)
				{
					if(!$userNotFoundMessage)
					{
						$this->message .= "<br /><br />\n"._PM_MESSAGE_NO_RECIPIENT_FOUND."<br /><br />\n";
						$userNotFoundMessage = TRUE;
						$this->userNotFoundMessage = TRUE;
					}
					
					$this->message .= trim($this->to[ $i ])."<br />\n";
				}
				else
				{
					if( $mess_cnt == 0 )
					{
						$this->message .= $this->br . $this->br . _PM_MESSAGE_SAVER_INBOX_FULL . $this->br . $this->br;
					}
					
					$user_link = new Link( "modules.php?name=Your_Account&user=" . $this->to[ $i ], "", $this->to[ $i ] );
					$this->message .= $user_link->toString() . $this->br;
					$mess_cnt++;
				}
			}
		}
		else
		{
			$this->error = _PM_MESSAGE_SAVER_OUTBOX_MAX;	
		}
	}
	
	function toString()
	{
		$return_list = "";
		
		if( strlen( $this->error ) == 0 )
		{
			if(!$this->userNotFoundMessage)
				$return_list .= _PM_MESSAGE_SAVED;
			else
				$return_list .= _PM_MESSAGE_TRYTOSAVE;
		}
		else
		{
			$return_list .= $this->error;	
		}
		
		$return_list .= $this->message;
		
		return $return_list;
	}
}
?>