<?php
class MessagesTable extends DB_Sql
{
	var $error     = "";
	var $message   = "";
	var $userdata  = array();
	var $table     = "";
	var $max_title = 0;
	var $max_per_page = 0;
	var $offset = 0;
	var $which = "";
	var $orderby = "";
	var $ordertype = "";
	var $linkordertype = "";
	var $form = "";
	
	function MessagesTable( $userdata, $which )
	{
		$this->max_title = _PM_CNF_MAX_TITLE;
		$this->max_per_page = _PM_CNF_MAX_PER_PAGE;
		
		// don't change this
		$this->userdata = $userdata;
		$this->which = $which;
		$this->offset = ( is_numeric( _getVar( "offset" ) ) ) ? intval( _getVar( "offset" ) ) : 0;
		if( strlen( _getVar( "orderby" ) ) != 0 )
		{
			switch( _getVar( "orderby" ) )
			{
				case "from_id":
					
					$this->orderby = "from_id";
				
					break;
				case "to_id":
					
					$this->orderby = "to_id";
				
					break;
				case "flag":
					
					$this->orderby = "flag";
				
					break;
				case "title":
					
					$this->orderby = "title";
				
					break;
				default:
					
					$this->orderby = "sendtime";
			}	
		}
		else
		{
			$this->orderby = "sendtime";	
		}
		
		if( _getVar( "ordertype" ) == "ASC" )
		{
			$this->ordertype = "";
			$this->linkordertype = "ASC";
		}
		else
		{
			$this->ordertype = " DESC";
			$this->linkordertype = "";
		}
		
		$this->form = new Form();
		$this->form->setAction( "modules.php" );
		$this->form->setMethod( "post" );
		$this->form->addHidden( "name", "PrivateMessages" );
		$this->form->addHidden( "which", $this->which );
		
		$this->buildTable( $which );
		
		if( is_array( _getVar( "marked_ids" ) ) && _getVar( "marked_op" ) == "delete" )
		{
			$this->deleteMessages( _getVar( "marked_ids" ) );	
			_locationHref( "modules.php?name=PrivateMessages&which=" . $this->which );
		}
		
		if( _getVar( "marked_op" ) == "delete_all" )
		{
			$this->deleteAllMessages();
			_locationHref( "modules.php?name=PrivateMessages&which=" . $this->which );
		}
	}
	
	function deleteAllMessages()
	{
		if( $this->which == "outbox" )
		{
				$this->query( "DELETE FROM " . _DBPREFIX . "_pm_inbox WHERE from_id='{$this->userdata[1]}' AND to_id<>{$this->userdata[0]} AND owner={$this->userdata[0]}" );	
		}
		else
		{
			$this->query( "DELETE FROM " . _DBPREFIX . "_pm_inbox WHERE to_id={$this->userdata[0]} AND owner={$this->userdata[0]}" );	
		}
	}
	
	function deleteMessages( $ids )
	{
		$ids_length = count( $ids );
		$ids_to_delete = "";
		
		for( $i = 0; $i < $ids_length; $i++ )
		{
			if( $i+1 < $ids_length )
			{
				$ids_to_delete .= "id=" . $ids[ $i ] . " AND owner={$this->userdata[0]} OR ";
			}
			else
			{
				$ids_to_delete .= "id="  . $ids[ $i ] . " AND owner={$this->userdata[0]};";
			}
		}

		if( strlen( $ids_to_delete ) != 0 )
		{
			$this->query( "DELETE FROM " . _DBPREFIX . "_pm_inbox WHERE $ids_to_delete" );
		}
	}
	
	function buildTable( $which )
	{
		switch( $which )
		{
			case "outbox":
					$this->query( "SELECT id FROM "._DBPREFIX."_pm_inbox"
								 ." WHERE"
						 		 ." from_id='" . $this->userdata[ 1 ] . "'"
						 		 ." AND"
						 		 ." to_id<>" . $this->userdata[ 0 ] . ""
						 		 ." AND"
						 		 ." owner=" . $this->userdata[ 0 ] . ""
						 		 ." ORDER BY " . $this->orderby . ""
						 		 ."" . $this->ordertype . ";" );
					
					$len = $this->nf();
						 		  		 
					$this->query( "SELECT * FROM "._DBPREFIX."_pm_inbox"
								 ." WHERE"
						 		 ." from_id='" . $this->userdata[ 1 ] . "'"
						 		 ." AND"
						 		 ." to_id<>" . $this->userdata[ 0 ] . ""
						 		 ." AND"
						 		 ." owner=" . $this->userdata[ 0 ] . ""
						 		 ." ORDER BY " . $this->orderby . ""
						 		 ."" . $this->ordertype . " LIMIT {$this->offset},{$this->max_per_page};" );
					
					$which_value = _OUTBOX;
						 		 
					break;
			
			default:
					$this->query( "SELECT id FROM "._DBPREFIX."_pm_inbox"
								 ." WHERE"
						 		 ." to_id=" . $this->userdata[ 0 ] . ""
						 		 ." AND"
						 		 ." owner=" . $this->userdata[ 0 ] . ""
						 		 ." ORDER BY " . $this->orderby . ""
						 		 ."" . $this->ordertype . ";" );
					
					$len = $this->nf();
					
					$this->query( "SELECT * FROM "._DBPREFIX."_pm_inbox"
								 ." WHERE"
						 		 ." to_id=" . $this->userdata[ 0 ] . ""
						 		 ." AND"
						 		 ." owner=" . $this->userdata[ 0 ] . ""
						 		 ." ORDER BY " . $this->orderby . ""
						 		 ."" . $this->ordertype . " LIMIT {$this->offset},{$this->max_per_page};" );
						 		 
					$which_value = _INBOX;
		}
		
		$table = new Table();
		$table->setWidth( "100%" );
		
		$flag   = new TableColumn();
		$title  = new TableColumn();
		$from   = new TableColumn();
		$to     = new TableColumn();
		$date   = new TableColumn();
		$marked = new TableColumn();
		
		$whichHead = new TableColumn();
		$whichHead->setColspan( 5 );
		$whichHead->setValue( $which_value );
		$whichHead->setAlign( "center" );
		$whichHeadRow = new TableRow();
		$whichHeadRow->addColumn( $whichHead );
		$table->addRow( $whichHeadRow );
		
		if( $this->linkordertype == "ASC" )
			$lio = "";
		else
			$lio = "ASC";
		
		$flag_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . $this->offset . "&amp;orderby=flag&amp;ordertype=$lio", "", _PM_FLAG );
		$flag->setValue( $flag_link->toString() );
		
		$title_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . $this->offset . "&amp;orderby=title&amp;ordertype=$lio", "", _PM_TITLE );
		$title->setValue( $title_link->toString() );
		
		$from_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . $this->offset . "&amp;orderby=from_id&amp;ordertype=$lio", "", _PM_FROM );
		$from->setValue( $from_link->toString() );
		
		$to_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . $this->offset . "&amp;orderby=to_id&amp;ordertype=$lio", "", _PM_TO );
		$to->setValue( $to_link->toString() );
		
		$date_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . $this->offset . "&amp;orderby=sendtime&amp;ordertype=$lio", "", _PM_DATE );
		$date->setValue( $date_link->toString() );
		
		$marked->setValue( _PM_MARKED );
			
		$head = new TableRow();
		$head->addColumn( $flag );
		$head->addColumn( $title );
		$head->addColumn( $from );
		$head->addColumn( $to );
		$head->addColumn( $date );
		$head->addColumn( $marked );
			
		$table->addRow( $head );
		
		if( $this->nf() != 0 )
		{
			while( $this->next_record() )
			{	
				$c_flag   = new TableColumn();
				$c_flag->setValue( $this->f( "flag" ) );
				
				$view_link = new Link( "modules.php?name=PrivateMessages&amp;op=view_message&amp;id=" . $this->f( "id" ), "", substr( stripslashes( $this->f( "title" ) ), 0, $this->max_title ) );
				$c_title  = new TableColumn();
				$c_title->setValue( $view_link->toString() );
				
				$c_from_link = new Link( "modules.php?name=Your_Account&user=" . $this->f( "from_id" ), 
									     "from_link", 
									     $this->f( "from_id" ) );
				
				$c_from   = new TableColumn();
				$c_from->setValue( $c_from_link->toString() );
				
				$newDB = new DB_Sql;
				$toName = _getUserNameById( $newDB, $this->f( "to_id" ) );
				$c_to_link = new Link( "modules.php?name=Your_Account&user=" . $toName, 
									     "to_link", 
									     $toName );
				
				$c_to  = new TableColumn();
				$c_to->setValue( $c_to_link->toString() );
				
				$c_date   = new TableColumn();
				$c_date->setValue( date( _STANDARDTIME, strtotime( $this->f( "sendtime" ) ) ) );
				
				$c_marked = new TableColumn();
				$this->form->addCheckbox( "marked_ids[]", $this->f( "id" ), $this->f( "marked" ) );
				$c_marked->setValue( $this->form->getElement( "marked_ids[]" ) );
				
				$row = new TableRow();
				$row->addColumn( $c_flag );
				$row->addColumn( $c_title );
				$row->addColumn( $c_from );
				$row->addColumn( $c_to );
				$row->addColumn( $c_date );
				$row->addColumn( $c_marked );
				
				$table->addRow( $row );
			}
			
			$this->form->addSelect( "marked_op", array( "delete" => 
															array( "value" => _PM_MESSAGES_TABLE_DELETE_SELECTED ),
														"delete_all" =>
															array( "value" => _PM_MESSAGES_TABLE_DELETE_ALL ) ) );
			$this->form->addSubmit( "sender", _SEND );
			$action_row = new TableRow();
			$action_col = new TableColumn();
			$action_col->setColspan( 6 );
			$action_col->setAlign( "right" );
			$action_col->setValue( $this->form->getElement( "marked_op" ) . $this->form->getElement( "sender" ) );
			$action_row->addColumn( $action_col );
			$table->addRow( $action_row );
			
			$next_str = "";
			$back_str = "";
			if( $len > ( $this->offset + $this->max_per_page ) )
			{
				$scroll_next_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . ( $this->offset + $this->max_per_page ) . "&amp;orderby=" . $this->orderby . "&amp;ordertype=" . $this->linkordertype . "", "", _NEXT );
				$next_str = $scroll_next_link->toString();
			}
			
			if( $this->offset - $this->max_per_page >= 0 )
			{
				$scroll_back_link = new Link( "modules.php?name=PrivateMessages&amp;which={$this->which}&amp;offset=" . ( $this->offset - $this->max_per_page ) . "&amp;orderby=" . $this->orderby . "&amp;ordertype=" . $this->linkordertype . "", "", _BACK );
				$back_str = $scroll_back_link->toString();
			}
			
			$scroll_row = new TableRow();
			$scroll_col = new TableColumn();
			$scroll_col->setColspan( 6 );
			$scroll_col->setAlign( "center" );
			$scroll_col->setValue( $back_str . " " . $next_str );
			$scroll_row->addColumn( $scroll_col );
			$table->addRow( $scroll_row );
		}
		else
		{
			$c_no_entries_td = new TableColumn();
			$c_no_entries_td->setColspan( 6 );
			$c_no_entries_td->setAlign( "center" );
			$c_no_entries_td->setValue( _NO_ENTRIES );
			$c_no_entries_tr = new TableRow();
			$c_no_entries_tr->addColumn( $c_no_entries_td );
			$table->addRow( $c_no_entries_tr );
		}
		
		$this->table = $table;
	}
	
	function toString()
	{
		$return_string = "";
		
		if( strlen( $this->error ) == 0 )
		{
			$return_string .= $this->form->getOpenLine();
			$return_string .= $this->table->toString();
			$return_string .= $this->form->getElement( "name" );
			$return_string .= $this->form->getElement( "which" );
			$return_string .= $this->form->getCloseLine();
		}
		else
		{
			$return_string = $this->error;  	
		}
		
		return $return_string;
	}
}

?>